local _G = getfenv(0)

function Skinner:Tablet()

	self:SecureHook(AceLibrary("Tablet-2.0"), "Open", function(tablet, parent)
		-- self:Debug("TabletOpen: [%s, %s]", tablet, parent)
		self:Skin_Tablet()
		end)
	self:SecureHook(AceLibrary("Tablet-2.0"), "Detach", function(tablet, parent)
		-- self:Debug("TabletDetach: [%s, %s]", tablet, parent)
		self:Skin_Tablet()
		end)

	self:Skin_Tablet()

end

local tabletsSkinned = {}

function Skinner:Skin_Tablet()
	if not self.db.profile.Tooltips.skin then return end

	if Tablet20Frame then
		local frame = Tablet20Frame
		if not tabletsSkinned["Tablet20Frame"] then
			-- self:Debug("Tablet20Frame")
			tabletsSkinned["Tablet20Frame"] = true
			self:applySkin(frame)
			-- hook these to stop the Backdrop colours from being changed 
			self:Hook(frame, "SetBackdropColor", function(r, g, b, a) end, true)
			self:Hook(frame, "SetBackdropBorderColor", function(r, g, b, a) end, true)
		end
		if self.db.profile.FadeHeight.enable and self.db.profile.FadeHeight.force then
			fh = self.db.profile.FadeHeight.value <= math.ceil(frame:GetHeight()) and self.db.profile.FadeHeight.value or math.ceil(frame:GetHeight())
		end
		if self.db.profile.Gradient.invert then
			frame.tfade:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 4, 4)
			if fh then frame.tfade:SetPoint("TOPRIGHT", frame, "BOTTOMRIGHT", -4, -(fh - 4))
			else frame.tfade:SetPoint("TOPRIGHT", frame, "TOPRIGHT", -4, -4) end
		else
			frame.tfade:SetPoint("TOPLEFT", frame, "TOPLEFT", 4, -4)
			if fh then frame.tfade:SetPoint("BOTTOMRIGHT", frame, "TOPRIGHT", -4, -(fh - 4))
			else frame.tfade:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", -4, 4) end
		end
	end
	
	local i = 1
	while _G["Tablet20DetachedFrame"..i] do
		local frame = _G["Tablet20DetachedFrame"..i]
		if not tabletsSkinned["Tablet20DetachedFrame"..i] then
			-- self:Debug("DetachedFrame: [%s, %s]", frame:GetName(), frame:GetParent():GetName() )
			tabletsSkinned["Tablet20DetachedFrame"..i] = true
			self:applySkin(frame)
			-- hook these to stop the Backdrop colours from being changed 
			self:Hook(frame, "SetBackdropColor", function(r, g, b, a) end, true)
			self:Hook(frame, "SetBackdropBorderColor", function(r, g, b, a) end, true)
		end
		if self.db.profile.FadeHeight.enable and self.db.profile.FadeHeight.force then
			fh = self.db.profile.FadeHeight.value <= math.ceil(frame:GetHeight()) and self.db.profile.FadeHeight.value or math.ceil(frame:GetHeight())
		end
		if self.db.profile.Gradient.invert then
			frame.tfade:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 4, 4)
			if fh then frame.tfade:SetPoint("TOPRIGHT", frame, "BOTTOMRIGHT", -4, -(fh - 4))
			else frame.tfade:SetPoint("TOPRIGHT", frame, "TOPRIGHT", -4, -4) end
		else
			frame.tfade:SetPoint("TOPLEFT", frame, "TOPLEFT", 4, -4)
			if fh then frame.tfade:SetPoint("BOTTOMRIGHT", frame, "TOPRIGHT", -4, -(fh - 4))
			else frame.tfade:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", -4, 4) end
		end
		i = i + 1
	end
	
end
